
// angular.module('mobility-app').controller('LoginCtrl', function(AppInfo, $timeout, $scope, $http, $state, $ionicLoading, $ionicViewSwitcher, $localstorage, $ionicHistory, UpdateService, AuthService) {
// 	var self = this;

// 	//-- controller variables - accessed from DOM
// 	self.loginData = {
// 		user: $localstorage.getLastLoggedUser() || '',
// 		password: ''
// 	};

// 	self.isLoginEnabled = function() {
// 		return (self.loginData.user.length > 0 && self.loginData.password.length > 0);
// 	};

// 	//-- error handling
// 	self.error = false;

// 	self.clear= function() {
// 		self.error = false;
// 	}

// 	//-- controller functions - accessed from DOM
// 	self.login = function() {
// 		if (!self.isLoginEnabled()) {
//             $ionicLoading.hide();
// 			return;
// 		}

// 		if (window.cordova) {
// 			cordova.plugins.Keyboard.close();
// 		}

// 		$ionicLoading.show();
// 		self.loginData.user = self.loginData.user ? self.loginData.user.toLowerCase() : self.loginData.user;

// 		AuthService.authenticate(self.loginData).then(function() {
// 			enterApp();
// 		},
// 		function(error) {
// 			$ionicLoading.hide();

// 			self.error = true;

// 			if (!error.data || !error.data.error_description) {
// 				return;
// 			}

// 			if (error.data.type == 'PasswordExpiredError') {
// 				alert('Password is expired');
// 				self.resetPassword();
// 			}
// 		});
// 	};

// 	self.resetPassword = function() {
// 		$ionicViewSwitcher.nextDirection("swap")
// 		$state.go('reset');

// 		/*alert('Going to reset URL: ' + AppInfo.ResetUserURL);
// 		if (window.cordova && cordova.InAppBrowser) {
// 			var ref = cordova.InAppBrowser.open(AppInfo.ResetUserURL, '_blank', 'location=no');
// 			ref.addEventListener('loaderror', function(event) {
// 				alert('Error loading Reset Password URL.');
// 			});
// 			$window.location.reload(true);
// 		}
// 		else {
// 			window.open(AppInfo.ResetUserURL);
// 		}*/
// 	};

// 	self.register = function() {
// 		$ionicViewSwitcher.nextDirection("swap")
// 		$state.go('register');

// 		/*alert('Going to register URL: ' + AppInfo.RegisterUserURL);
// 		if (window.cordova && cordova.InAppBrowser) {
// 			var ref = cordova.InAppBrowser.open(AppInfo.RegisterUserURL, '_blank', 'location=no');
// 			ref.addEventListener('loaderror', function(event) {
// 				alert('Error loading New Account URL.');
// 			});
// 			$window.location.reload(true)
// 		}
// 		else {
// 			window.open(AppInfo.RegisterUserURL);
// 		}*/
// 	};

// 	//-- ENTER THE APPLICATION
// 	function enterApp() {
// 		// reset password
// 		self.loginData.password = '';

// 		// save user for next login
// 		$localstorage.setLastLoggedUser(self.loginData.user);

// 		// back button should never reach the login screen
// 		$ionicHistory.nextViewOptions({
// 			historyRoot: true,
// 			disableBack: true
// 		});

// 		window.cordova ? $ionicViewSwitcher.nextDirection('enter') : $ionicViewSwitcher.nextDirection('swap');
// 		$state.go('app.dashboard');
// 	};

// 	//-- AUTO LOGIN
// 	function autoLogin() {
// 		if ($localstorage.getAutoLogin() === 'ENABLED' && $localstorage.getLastLoggedUser()) {

// 			self.loginData.user = self.loginData.user ? self.loginData.user.toLowerCase() : self.loginData.user;

// 			AuthService.authenticate(self.loginData).then(function() {
// 				enterApp();
// 			},
// 			function(error) {
// 				$ionicLoading.hide();
// 			});
// 		}
// 		else {
// 			$ionicLoading.hide();

// 			if (!self.loginData.user || self.loginData.user.length < 1) {
// 				$('#input-user').focus();
// 			}
// 			else if (!self.loginData.password || self.loginData.password.length < 1) {
// 				$('#input-pass').focus();
// 			}
// 		}
// 	};

// 	//-- CHECK FOR UPDATES
// 	function checkUpdates() {
// 		$ionicLoading.show();

// 		// desktop
// 		if (!window.cordova) {
// 			autoLogin();
// 			return;
// 		}

// 		// this method always resolves with no errors
// 		UpdateService.update().then(function() {
// 			autoLogin();
// 		});
// 	};

// 	checkUpdates();

// })

// .controller('ResetPasswordCtrl', function(AppInfo, $state, $ionicViewSwitcher, BackendService) {
// 	var self = this;

// 	self.submitted = false;
// 	self.errorMsg = "";
// 	self.email = '';

// 	self.close = function() {
// 		$ionicViewSwitcher.nextDirection("swap")
// 		$state.go("login");
// 	};

// 	self.isDataValid = function() {
// 		return (self.email && self.email.length > 5);
// 	};
	
// 	self.resetPassword = function() {
// 		if (!self.isDataValid()) {
// 			return;
// 		}

//         if (AppInfo.useMockedData) {
//         	self.errorMsg = ["There is no connection to the backend. Activity cannot be performed."];
//         	return;
//         }

//         var submitData = {
//         	"email": self.email
//         };

//         BackendService.submitPasswordReset(submitData).then(function() {
//         	self.submitted = true;
//         },
//         function(error) {
//    		    if (error.status == 400) {
//    		    	if (error.data.type == 'PasswordNotAgedYetError') {
//    		    		self.errorMsg = ["Password was recently changed"];
//    		    	}
//    		    	else if (error.data.type == 'UserLockedError') {
//    		    		self.errorMsg = ["Your account is locked, please contact admin"];
//    		    	}
//    		        else if (error.data.type == 'UserNotValidatedError') {
//    		        	self.errorMsg = ["Your account is not validated yet, please contact admin"];
//    		        }
//    		        else if (error.data.type == 'UserNotApprovedError') {
//    		        	self.errorMsg = ["Your account is not approved yet, please contact admin"];
//    		        }
//    		        else if (error.data.type == 'UserDisabledError') {
//    		        	self.errorMsg = ["Your account is disabled, please contact admin"];
//    		        }
//    		        else {
//    		        	self.errorMsg = ["Wrong email"];
//    		        }
//    		    } 
//    	        else if (error.status == 500 && error.data.type == 'ResourceNotFoundError' && error.data.message == 'Token not found or expired') {
//    	        	self.errorMsg = ["Invalid request"];
//    	        }
//    	        else {
//    	        	self.errorMsg = ["Server error encountered. Please try again later"];
//    	        }
//         });
// 	};

// 	function formatErrors(messages, msg) {
// 	    return messages.reduce(function(a, b) {
// 	        return a.concat(b + msg);
// 	    }, []);
// 	}

// })

// .controller('NewAccountCtrl', function(AppInfo, $state, $ionicViewSwitcher, BackendService, backendData) {
// 	var self = this;

// 	self.policy = backendData;

// 	self.submitted = false;
// 	self.errorMsg = "";

// 	//-- Form Data
// 	self.data = {
// 		email: "",
// 		pass: "",
// 		firstName: "",
// 		lastName: ""
// 	};

// 	self.isDataValid = function() {
// 		return self.data.email.length > 0 && self.data.pass.length > 0 && self.data.firstName.length > 0 && self.data.lastName.length > 0;
// 	};

// 	self.close = function() {
// 		$ionicViewSwitcher.nextDirection("swap")
// 		$state.go("login");
// 	};

// 	self.createAccount = function() {
// 		if (!self.isDataValid()) {
// 			return;
// 		}

// 		self.errorMsg = "";
		
	
// 	        var badChars = /@/;
	        
// 	        if(badChars.test(self.data.email))
// 	        {
// 		    	self.errorMsg = ["Please provide only the email address prefix (up to the @ sign)"];
// 		        return;
// 		    }


// 	    var errors = [
// 	        [self.data.email, "Email"],
// 	        [self.data.domain, "Domain"],
// 	        [self.data.pass, "Password"],
// 	        [self.data.firstName, "First Name"],
// 	        [self.data.lastName, "Last Name"],
// 	        [self.data.role, "Role"]
// 	    ].reduce(function(a, b) {
// 	        var e = b[0];
// 	        var m = b[1];
// 	        return (!e || 0 === e.length) ? a.concat(m) : a;
// 	    }, []);

// 	    if (errors.length > 0) {
// 	    	self.errorMsg = formatErrors(errors, " not populated");
// 	        return;
// 	    }

//        /* if (AppInfo.useMockedData) {
//         	self.errorMsg = ["There is no connection to the backend. Activity cannot be performed."];
//         	return;
//         }*/
        
       
//         var submitData = {
//             "email": self.data.email.toLowerCase() + "@" + self.data.domain.toLowerCase(),
//             "password": self.data.pass,
//             "firstName": self.data.firstName,
//             "lastName": self.data.lastName,
//             "role": self.data.role
//         };

//         BackendService.submitUserData(submitData).then(function() {
//         	self.submitted = true;
//         },
//         function(error) {
// 		    var messages;
// 		    if (error.status == 400 && error.data.type == 'InvalidInputError') {
// 		    	messages = error.data.errors.map(function(a) {
// 		    		return a["input"] + " " + a["message"]
// 		    	});
// 		    } else if (error.status == 400 && error.data.type == 'PasswordPolicyViolatedError') {
// 		    	messages = error.data.errors;
// 		    } else if (error.status == 409) {
// 		    	messages = [error.data.message];
// 		    } else {
// 		    	messages = ["Server error encountered. Please try again."];
// 		    }

// 		    self.errorMsg = formatErrors(messages, "");
//         });
// 	};

// 	function formatErrors(messages, msg) {
// 	    return messages.reduce(function(a, b) {
// 	        return a.concat(b + msg);
// 	    }, []);
// 	}
// });


angular.module('mobility-app').controller('LoginCtrl', function(AppInfo, $timeout, $scope, $http, $state, $ionicLoading, $ionicViewSwitcher, $localstorage, $ionicHistory, UpdateService, AuthService) {	
	var self = this;

	self.loginData = {
		username: $localstorage.getLastLoggedUser() || '',
		password: '',
		autologin: false
	};

	self.isLoginEnabled = function() {
		return (self.loginData.username.length > 0 && (self.loginData.password.length > 0 || self.loginData.autologin));
	};


	//-- error handling
	self.error = false;

	self.clear = function() {
		self.error = false;
	};


	self.login = function() {
		if (!self.isLoginEnabled()) {
			return;
		}

		$ionicLoading.show();

		//self.loginData.username = self.loginData.username.toLowerCase();

		self.loginData.username = self.loginData.username ? self.loginData.username.toLowerCase() : self.loginData.username;


		if (window.cordova) {
			AuthService.signIn(self.loginData).then(function (response) {
				self.loginData.password = ''; // do not keep the password stored
				enterApp();
			},
			function (error) {
				alert(error);
				$ionicLoading.hide();
			});
		}
		else {
			enterApp();
		}
	};

	//-- ENTER THE APPLICATION
	function enterApp() {
		// reset password
		self.loginData.password = '';


		$http.defaults.headers.common['Authorization'] = 'Eds ' + self.loginData.username;
		$http.defaults.headers.common['attEDSApplication'] = 'iMoc';
		

		// save user for next login
		$localstorage.setLastLoggedUser(self.loginData.username);

		// back button should never reach the login screen
		$ionicHistory.nextViewOptions({
			historyRoot: true,
			disableBack: true
		});

		window.cordova ? $ionicViewSwitcher.nextDirection('enter') : $ionicViewSwitcher.nextDirection('swap');
		$state.go('app.dashboard');
	};



	// AUTO LOGIN
	function autoLogin() {
		var user = $localstorage.getLastLoggedUser();

		$ionicLoading.hide();

		if (!user || user.trim().length < 1 || $localstorage.getAutoLogin() != 'ENABLED') {
			return;
		}


		// self.loginData.username = self.loginData.username ? self.loginData.username.toLowerCase() : self.loginData.username;

		AuthService.isAutoLoginSupported().then(function () {
			AuthService.validAutoLoginInfo(user).then(function() {
				self.loginData.autologin = true;
				self.login();
			});
		});
	};


	//-- CHECK FOR UPDATES
	function checkUpdates() {
		$ionicLoading.show();

		// desktop
		if (!window.cordova) {
			$ionicLoading.hide();
			autoLogin();
			return;
		}

		// this method always resolves with no errors
		UpdateService.update().then(function() {
			$ionicLoading.hide();
			autoLogin();
		});
	};

	checkUpdates();
});
