
angular.module('mobility-app').controller('ReportCtrl', function($ionicLoading, $ionicViewSwitcher, $state, reportFile) {
	var self = this;

	self.currentDate = 'Data loaded at ' + moment().format('MMMM DD, YYYY HH:mm:ss');
	self.template = reportFile;

	// NAVIGATION
	self.goBack = function() {
		$ionicLoading.show();
		window.cordova ? $ionicViewSwitcher.nextDirection('back') : $ionicViewSwitcher.nextDirection('swap');
		$state.go('app.dashboard');
	};


	self.isMobile = function() {
		return (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) || false;
	};
});
