
angular.module('mobility-app', ['ionic', 'ngCordova'])
	.run(function($ionicPlatform) {
	    $ionicPlatform.ready(function() {

	    	ionic.Platform.fullScreen();
	    	if (window.StatusBar) {
	    		// hide status bar
	    		StatusBar.hide();
	    	}

	    	// change orientation for phones
	    	if (screen.lockOrientation) {
	    		if (screen.width < 768) {
	    			screen.lockOrientation("portrait");
	    		} else {
	    			screen.lockOrientation("landscape");
	    		}
	    	}

	    	// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard for form inputs)
	    	if (window.cordova && window.cordova.plugins.Keyboard) {
	    		//cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
	    		cordova.plugins.Keyboard.disableScroll(false);
	    	}
	    });
	})

	//Enable App to be open from an external link
	// http://sysgears.com/notes/launch-ionic-app-with-a-web-or-email-link/
	.run(['$state', '$window', function($state, $window) {
		$window.addEventListener('LaunchUrl', function(event) {
			$state.go('login');
		});
	}]);

	function handleOpenURL(url) {
		setTimeout( function() {
			var event = new CustomEvent('LaunchUrl', {detail: {'url': url}});
			window.dispatchEvent(event);
		}, 0);
	};

