
angular.module('mobility-app').controller('AppCtrl', function($state, MenuService) {
	var self = this;

	self.selectedTab = $state.current.name.replace('app.', '');

	// NAVIGATION
	self.goTo = function(tabName) {
		if (tabName == self.selectedTab && tabName == $state.current.name.replace('app.', '')) {
			return;
		}

		self.selectedTab = tabName;

		MenuService.goTo(tabName);
	};

	//-- Allow other controllers to select proper menu
	var selectMenu = function(state) {
		if (!state || state.length < 1) {
			return;
		}

		self.selectedTab = state.replace('app.', '');
	};

	MenuService.registerSelectCallBack(selectMenu);
});
