var MockedData = {
	"user": {
		"status": 200,
		"data": {
			"user": {
				"firstName": "lorem",
				"lastName": "ipsium",
				"email": "lorem@amdocs.com",
				"active": true
			},
			"profiles": [
				{
					"id": 0,
					"name": "ITExecutive"
				}
			]
		}
	},
	"overview": {
		"status": 200,
		"data": {
			"graphs": [
				{
					"id": 27,
					"title": "All iPhones Activations Hourly",
					"metricSeries": [
						{
							"info": {
								"id": 1114,
								"name": "All iPhones Transactions Hourly Day-0",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-08-25T00:00:00 -0500",
									"value": 540.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T01:00:00 -0500",
									"value": 442.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T02:00:00 -0500",
									"value": 346.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T03:00:00 -0500",
									"value": 371.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T04:00:00 -0500",
									"value": 344.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T05:00:00 -0500",
									"value": 467.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T06:00:00 -0500",
									"value": 535.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T07:00:00 -0500",
									"value": 875.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T08:00:00 -0500",
									"value": 1382.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T09:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T10:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T11:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T12:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T13:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T14:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T15:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T16:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T17:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T18:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T19:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T20:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T21:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T22:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T23:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				},
				{
					"id": 2,
					"title": "TLG Transactions per Minute",
					"metricSeries": [
						{
							"info": {
								"id": 1000,
								"name": "TODAY",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T01:00:00 -0500",
									"value": 188019.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T02:00:00 -0500",
									"value": 213570.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T03:00:00 -0500",
									"value": 244884.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T04:00:00 -0500",
									"value": 242259.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T05:00:00 -0500",
									"value": 316452.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T06:00:00 -0500",
									"value": 477243.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T07:00:00 -0500",
									"value": 613692.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T08:00:00 -0500",
									"value": 765282.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T09:00:00 -0500",
									"value": 891984.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T10:00:00 -0500",
									"value": 944136.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T11:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T12:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T13:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T14:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T15:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T16:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T17:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T18:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T19:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T20:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T21:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T22:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T23:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1001,
								"name": "Week ago",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-08-25T00:00:00 -0500",
									"value": 285882.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T01:00:00 -0500",
									"value": 245907.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T02:00:00 -0500",
									"value": 194832.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T03:00:00 -0500",
									"value": 231189.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T04:00:00 -0500",
									"value": 249300.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T05:00:00 -0500",
									"value": 327378.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T06:00:00 -0500",
									"value": 417108.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T07:00:00 -0500",
									"value": 534093.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T08:00:00 -0500",
									"value": 720612.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T09:00:00 -0500",
									"value": 901038.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T10:00:00 -0500",
									"value": 963000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T11:00:00 -0500",
									"value": 978861.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T12:00:00 -0500",
									"value": 1007952.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T13:00:00 -0500",
									"value": 1011198.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T14:00:00 -0500",
									"value": 921270.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T15:00:00 -0500",
									"value": 979866.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T16:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T17:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T18:00:00 -0500",
									"value": 811140.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T19:00:00 -0500",
									"value": 728472.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T20:00:00 -0500",
									"value": 640992.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T21:00:00 -0500",
									"value": 570708.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T22:00:00 -0500",
									"value": 544119.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T23:00:00 -0500",
									"value": 410508.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1002,
								"name": "Peak Retail Volume",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-08-25T00:00:00 -0500",
									"value": 245133.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T01:00:00 -0500",
									"value": 202221.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T02:00:00 -0500",
									"value": 199389.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T03:00:00 -0500",
									"value": 156768.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T04:00:00 -0500",
									"value": 155277.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T05:00:00 -0500",
									"value": 204195.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T06:00:00 -0500",
									"value": 445398.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T07:00:00 -0500",
									"value": 689118.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T08:00:00 -0500",
									"value": 963153.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T09:00:00 -0500",
									"value": 968706.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T10:00:00 -0500",
									"value": 1156182.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T11:00:00 -0500",
									"value": 1071246.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T12:00:00 -0500",
									"value": 1060059.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T13:00:00 -0500",
									"value": 1040241.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T14:00:00 -0500",
									"value": 1027458.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T15:00:00 -0500",
									"value": 1027419.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T16:00:00 -0500",
									"value": 1009650.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T17:00:00 -0500",
									"value": 961704.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T18:00:00 -0500",
									"value": 840774.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T19:00:00 -0500",
									"value": 735102.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T20:00:00 -0500",
									"value": 595047.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T21:00:00 -0500",
									"value": 482235.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T22:00:00 -0500",
									"value": 390051.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T23:00:00 -0500",
									"value": 343923.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1003,
								"name": "25% TPM Limit",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-08-25T00:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T01:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T02:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T03:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T04:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T05:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T06:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T07:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T08:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T09:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T10:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T11:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T12:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T13:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T14:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T15:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T16:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T17:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T18:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T19:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T20:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T21:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T22:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T23:00:00 -0500",
									"value": 1200000.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1004,
								"name": "120% TPM Limit",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-08-25T00:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T01:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T02:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T03:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T04:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T05:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T06:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T07:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T08:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T09:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T10:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T11:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T12:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T13:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T14:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T15:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T16:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T17:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T18:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T19:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T20:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T21:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T22:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T23:00:00 -0500",
									"value": 1980000.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			],
			"gauges": [
				{
					"id": 1,
					"title": "Activations",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0.0,
					"maxValue": 100000.0,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1005,
							"name": "Activations",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T09:00:00 -0500",
							"value": 4486.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1006,
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1007,
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 0.0,
					"pcntDiffToMinorMetric": 0.0,
					"history": [
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T09:00:00 -0500",
							"value": 4486.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T08:00:00 -0500",
							"value": 2986.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T07:00:00 -0500",
							"value": 1765.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T06:00:00 -0500",
							"value": 271.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T05:00:00 -0500",
							"value": 39.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T04:00:00 -0500",
							"value": 15.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T03:00:00 -0500",
							"value": 13.0,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 1,
							"title": "Activations",
							"date": "2017-08-25T02:00:00 -0500",
							"value": 25.0,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 2,
					"title": "Upgrades and Data Change",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0.0,
					"maxValue": 3000000.0,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 1008,
							"name": "Upgrades Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 495911.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1009,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 48144.0,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1010,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 995010.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 931.0,
					"pcntDiffToMinorMetric": -50.0,
					"history": [
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T10:00:00 -0500",
							"value": 495911.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T09:00:00 -0500",
							"value": 431999.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T08:00:00 -0500",
							"value": 384363.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T07:00:00 -0500",
							"value": 342078.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T06:00:00 -0500",
							"value": 311421.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T05:00:00 -0500",
							"value": 288040.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T04:00:00 -0500",
							"value": 267568.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T03:00:00 -0500",
							"value": 208900.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Data Change",
							"date": "2017-08-25T02:00:00 -0500",
							"value": 163726.0,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 3,
					"title": "Sim Changes",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0.0,
					"maxValue": 500000.0,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1011,
							"name": "Sim Changes Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 14266.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1012,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 4267.0,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1013,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 13766.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 235.0,
					"pcntDiffToMinorMetric": 4.0,
					"history": [
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T10:00:00 -0500",
							"value": 14266.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T09:00:00 -0500",
							"value": 8680.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T08:00:00 -0500",
							"value": 5457.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T07:00:00 -0500",
							"value": 3258.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T06:00:00 -0500",
							"value": 2256.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T05:00:00 -0500",
							"value": 1875.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T04:00:00 -0500",
							"value": 1675.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T03:00:00 -0500",
							"value": 1523.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-08-25T02:00:00 -0500",
							"value": 1310.0,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 4,
					"title": "Cancellations",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0.0,
					"maxValue": 500000.0,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1014,
							"name": "Cancellations Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 27994.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1015,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 2367.0,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1016,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 26755.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 1083.0,
					"pcntDiffToMinorMetric": 5.0,
					"history": [
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T10:00:00 -0500",
							"value": 27994.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T09:00:00 -0500",
							"value": 24780.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T08:00:00 -0500",
							"value": 22712.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T07:00:00 -0500",
							"value": 20837.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T06:00:00 -0500",
							"value": 19748.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T05:00:00 -0500",
							"value": 19017.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T04:00:00 -0500",
							"value": 18229.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T03:00:00 -0500",
							"value": 17079.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-08-25T02:00:00 -0500",
							"value": 12687.0,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 5,
					"title": "Net Additions",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0.0,
					"maxValue": 500000.0,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 1017,
							"name": "Net Additions Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": -10767.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1018,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 2427.0,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1019,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-08-25T10:00:00 -0500",
							"value": 49264.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -543.0,
					"pcntDiffToMinorMetric": -121.0,
					"history": [
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T10:00:00 -0500",
							"value": -10767.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T09:00:00 -0500",
							"value": -13824.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T08:00:00 -0500",
							"value": -15572.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T07:00:00 -0500",
							"value": -16382.0,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T06:00:00 -0500",
							"value": -16923.0,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T05:00:00 -0500",
							"value": -16727.0,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T04:00:00 -0500",
							"value": -16204.0,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T03:00:00 -0500",
							"value": -15218.0,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-08-25T02:00:00 -0500",
							"value": -11023.0,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				}
			],
			"issues": [
				{
					"id": 1000060469,
					"date": "2017-08-25T02:32:22 -0500",
					"details": [
						{
							"Application": "Telegence CSM"
						},
						{
							"Severity": "P2"
						},
						{
							"Start time": "2017-08-25T02:32:22 -0500"
						},
						{
							"Issue": "Multiple Windows servers which are a part of the Citrix farm were not accessible."
						},
						{
							"Business impact": "There was no impact to onlines as we had redundancy in place."
						},
						{
							"Root cause": "SA identified storage related errors in the VM log. Storage ticket # 000000235251372 has been created for further investigation."
						},
						{
							"Resolution manager": "jf631g"
						},
						{
							"User name": "SG461K"
						},
						{
							"Status": "Resolved"
						},
						{
							"Update notes": "SA joined and identified there were a few disconnected ESXi hosts along with storage related errors in VM log. A reboot was suggested by SA in order to fix the issue. VMWare SA performed a reboot and the hosts were back up online."
						}
					]
				},
				{
					"id": 1000060468,
					"date": "2017-08-24T22:08:07 -0500",
					"details": [
						{
							"Application": "Telegence CSM"
						},
						{
							"Severity": "Proactive"
						},
						{
							"Start time": "2017-08-24T22:08:07 -0500"
						},
						{
							"Issue": "Support team was facing issues during prep-work for EST markets."
						},
						{
							"Business impact": "TUX bounce might have been delayed had the prep-work not finished by 2300CT."
						},
						{
							"Root cause": "An issue with WAS process was identified which prevented maps to be generated properly. Infra worked on it and has been fixed. The issue has been mitigated."
						},
						{
							"Resolution manager": "bt415a"
						},
						{
							"User name": "SK8224"
						},
						{
							"Status": "Resolved"
						},
						{
							"Update notes": "A manual TUX bounce was started on time and has been completed. No delays observed. Application support teams reported everything's good after the bounce."
						}
					]
				},
				{
					"id": 1000060446,
					"date": "2017-08-24T05:49:17 -0500",
					"details": [
						{
							"Application": "Telegence CSM"
						},
						{
							"Severity": "Proactive"
						},
						{
							"Start time": "2017-08-24T05:49:17 -0500"
						},
						{
							"Issue": "SDBA was unable to start the GG processes for PMDY25A on the server dhpcdbc4 after the work scheduled CR 4019282"
						},
						{
							"Business impact": "The GG processes not working was causing data mismatch between the cross market and local market DBs as well as NCI DB. Hence if a customer who has moved to another market; tries to move again; CSR would have been unable to process the request as the data would not be updated. No user complains were received."
						},
						{
							"Root cause": "The impacted FS were cluster aware which is why they did not come up automatically when the server was brought up."
						},
						{
							"Resolution manager": "NA"
						},
						{
							"User name": "AK5480"
						},
						{
							"Status": "Resolved"
						},
						{
							"Update notes": "The impacted FS were cluster aware which is why they did not come up automatically when the server was brought up. SA brought up the FS manually. They then updated the configuration to vg so that the FS get started from the FSTAB automatically next time when the server is rebooted.\r\nSDBA bought up the GG processes for cross market DB successfully. ADBA and CSM T1 validated the database and the table on cross market DB."
						}
					]
				},
				{
					"id": 1000060444,
					"date": "2017-08-24T03:36:46 -0500",
					"details": [
						{
							"Application": "Telegence CSM"
						},
						{
							"Severity": "Proactive"
						},
						{
							"Start time": "2017-08-24T03:36:46 -0500"
						},
						{
							"Issue": "One of the customer database server (olphcda1) for NBI was responding slow."
						},
						{
							"Business impact": "There was no impact to production as the traffic for NBI is being served by its primary node (olphcda2). This is just a failover option for NBI."
						},
						{
							"Root cause": "SA will further investigate with HP vendor through CASE ID : 5322390348 to determine the cause of slowness."
						},
						{
							"Resolution manager": "td858p"
						},
						{
							"User name": "JITENDER.MAHATO"
						},
						{
							"Status": "Resolved"
						},
						{
							"Update notes": "Server was not accessible to SDBA; when they were trying to failover the traffic from node2 to node1 as part of an OS patch activity. SA was engaged and they found slowness in the server. A server reboot was performed to help mitigate the issue. After which; SDBA successfully validated the DB services. SA will further investigate with HP vendor through CASE ID : 5322390348 to determine the cause of slowness."
						}
					]
				}
			],
			"isMornAvailEnabled": false
		}
	},
	"overview/activations/weekly": {
		"status": 200,
		"data": {
			"title": "Activations Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 4,
					"title": "Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 100507,
								"name": "Activations Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 40665.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 34025.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 18770.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 21902.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 20098.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 27741.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 9170.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/activations/monthly": {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 4,
					"title": "Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 100507,
								"name": "Activations Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"value": 6854.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"value": 1176.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"value": 5568.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"value": 5314.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"value": 3147.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"value": 6036.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"value": 7285.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"value": 17686.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"value": 10094.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"value": 7658.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"value": 5877.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"value": 3777.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"value": 9065.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"value": 8735.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"value": 9603.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 9982.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 40665.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 34025.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 18770.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 21902.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 20098.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 27741.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 9170.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/upgrades/weekly": {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 10,
					"title": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 110001,
								"name": "Upgrades Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 402981.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 272025.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 139920.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 184902.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 189111.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 346049.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 127065.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/upgrades/monthly": {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 11,
					"title": "Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 110001,
								"name": "Upgrades Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"value": 162464.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"value": 157212.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"value": 50114.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"value": 75366.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"value": 63317.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"value": 104432.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"value": 155829.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"value": 297517.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"value": 175870.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"value": 183184.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"value": 152591.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"value": 247939.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"value": 179284.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"value": 167809.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"value": 160471.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 152826.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 402981.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 272025.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 139920.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 184902.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 189111.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 346049.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 127065.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/sim-changes/weekly": {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 12,
					"title": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 110101,
								"name": "Sim Changes Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 11747.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 11712.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 6695.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 10704.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 10578.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 16383.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 6623.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/sim-changes/monthly": {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 13,
					"title": "Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 110101,
								"name": "Sim Changes Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"value": 5078.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"value": 252.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"value": 4210.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"value": 4537.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"value": 2896.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"value": 4101.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"value": 5673.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"value": 42993.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"value": 5071.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"value": 5402.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"value": 4954.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"value": 3555.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"value": 5048.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"value": 4579.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"value": 4770.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 4630.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 11747.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 11712.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 6695.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 10704.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 10578.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 16383.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 6623.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/cancellations/weekly": {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 14,
					"title": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 110201,
								"name": "Cancellations Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 10883.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 8052.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 7921.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 9106.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 12471.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 23567.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 8964.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/cancellations/monthly": {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 15,
					"title": "Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 110201,
								"name": "Cancellations Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"value": 12164.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"value": 5920.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"value": 2963.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"value": 3298.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"value": 3011.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"value": 5243.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"value": 4753.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"value": 10272.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"value": 6572.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"value": 11545.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"value": 13159.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"value": 13533.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"value": 4690.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"value": 6358.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"value": 4109.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 4221.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 10883.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 8052.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 7921.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 9106.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 12471.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 23567.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 8964.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/net-additions/weekly": {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 16,
					"title": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 110301,
								"name": "Net Additions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 29782.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 25973.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 10849.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 12796.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 7627.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 4174.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 206.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/net-additions/monthly": {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 17,
					"title": "Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 110301,
								"name": "Net Additions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"value": -5310.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"value": -4744.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"value": 2605.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"value": 2016.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"value": 136.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"value": 793.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"value": 2532.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"value": 7414.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"value": 3522.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"value": -3887.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"value": -7282.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"value": -9756.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"value": 4375.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"value": 2377.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"value": 5494.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 5761.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 29782.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 25973.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 10849.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 12796.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 7627.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 4174.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 206.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/iphone-transactions/weekly": {
		"status": 200,
		"data": {
			"title": "iPhone Transactions Weekly",
			"metrics": [],
			"gauges": [
				{
					"id": 26,
					"title": "iPhone Total Transactions Daily Day-6|Date^Total Activations^Change % From Last Week",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1114000005,
							"name": "iPhone Total Transactions Daily Day-6",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 202751.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 111400000501,
							"name": "iPhone Total Transactions Daily Day-6 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 78161.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 160.0,
					"history": []
				},
				{
					"id": 25,
					"title": "iPhone Total Transactions Daily Day-5",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1114000004,
							"name": "iPhone Total Transactions Daily Day-5",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 202789.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 111400000401,
							"name": "iPhone Total Transactions Daily Day-5 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 74362.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 173.0,
					"history": []
				},
				{
					"id": 24,
					"title": "iPhone Total Transactions Daily Day-4",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1114000003,
							"name": "iPhone Total Transactions Daily Day-4",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 133809.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 111400000301,
							"name": "iPhone Total Transactions Daily Day-4 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 62640.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 114.0,
					"history": []
				},
				{
					"id": 23,
					"title": "iPhone Total Transactions Daily Day-3",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1114000002,
							"name": "iPhone Total Transactions Daily Day-3",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 114500.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 111400000201,
							"name": "iPhone Total Transactions Daily Day-3 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 76961.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 49.0,
					"history": []
				},
				{
					"id": 22,
					"title": "iPhone Total Transactions Daily Day-2",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1114000001,
							"name": "iPhone Total Transactions Daily Day-2",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 132505.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 111400000101,
							"name": "iPhone Total Transactions Daily Day-2 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 79187.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 68.0,
					"history": []
				},
				{
					"id": 21,
					"title": "iPhone Total Transactions Daily Day-1",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1114000000,
							"name": "iPhone Total Transactions Daily Day-1",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 84003.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 111400000001,
							"name": "iPhone Total Transactions Daily Day-1 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 75848.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 11.0,
					"history": []
				},
				{
					"id": 20,
					"title": "iPhone Total Transactions Daily Day-0",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 1114000,
							"name": "iPhone Total Transactions Daily",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 13973.0,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1114000006,
							"name": "iPhone Total Transactions Daily Previous Week",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2017-08-24T00:00:00 -0500",
							"value": 74783.0,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -81.0,
					"history": []
				}
			],
			"graphs": [
				{
					"id": 28,
					"title": "iPhone Transactions Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1114000,
								"name": "iPhone Total Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 202751.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 202789.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 133809.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 114500.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 132505.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 84003.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 13973.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1111000,
								"name": "iPhone 6 Plus Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 4018.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 3931.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 3049.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 3773.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 4163.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 3948.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 856.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1112000,
								"name": "iPhone SE Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 5204.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 4908.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 3324.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 4598.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 4931.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 4783.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 875.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1113000,
								"name": "iPhone 7 Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 19062.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 19593.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 13474.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 17351.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 18204.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 27312.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 3039.0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1115000,
								"name": "iPhone 7 Plus Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 18590.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 19434.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 13391.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 16359.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 16475.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 15719.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 2434.0,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},
	"overview/iphone-transactions/monthly": {
		"status": 200,
		"data": {
			"title": "iPhone Transactions Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 28,
					"title": "iPhone Transactions Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1114000,
								"name": "iPhone Total Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"value": 80911.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"value": 71639.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"value": 75938.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"value": 80710.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"value": 81498.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"value": 59097.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"value": 76663.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"value": 80075.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"value": 199592.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"value": 77851.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"value": 78161.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"value": 74362.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"value": 62640.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"value": 76961.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"value": 79187.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"value": 75848.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 74783.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 202751.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 202789.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 133809.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 114500.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 132505.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 84003.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 13973.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1111000,
								"name": "iPhone 6 Plus Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 3885.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 4018.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 3931.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 3049.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 3773.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 4163.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 3948.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 856.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1112000,
								"name": "iPhone SE Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 4860.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 5204.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 4908.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 3324.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 4598.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 4931.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 4783.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 875.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1113000,
								"name": "iPhone 7 Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 17939.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 19062.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 19593.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 13474.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 17351.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 18204.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 27312.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 3039.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1115000,
								"name": "iPhone 7 Plus Transactions Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-17T00:00:00 -0500",
									"value": 16592.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-18T00:00:00 -0500",
									"value": 18590.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-19T00:00:00 -0500",
									"value": 19434.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-20T00:00:00 -0500",
									"value": 13391.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-21T00:00:00 -0500",
									"value": 16359.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-22T00:00:00 -0500",
									"value": 16475.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-23T00:00:00 -0500",
									"value": 15719.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-24T00:00:00 -0500",
									"value": 2434.0,
									"status": "GRAY"
								},
								{
									"date": "2017-08-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-08-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}
};
